﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using Syncfusion.XForms.DataForm;
using Syncfusion.XForms.DataForm.Editors;
using Syncfusion.XForms.TreeView;
using Xamarin.Forms;

namespace DataForm
{
    public class DataFormBehavior : Behavior<ContentPage>
    {
        SfDataForm dataForm;
        SfTreeView treeView;
        static ContactsInfo ContactsInfo;
        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            dataForm = bindable.FindByName<SfDataForm>("dataForm");
            if(dataForm != null && ContactsInfo != null)
            {
                dataForm.DataObject = ContactsInfo;
            }
            treeView = bindable.FindByName<SfTreeView>("treeView");
            if(treeView != null)
            {
                treeView.ItemTapped += TreeView_ItemTapped;
            }
        }

        private async void TreeView_ItemTapped(object sender, Syncfusion.XForms.TreeView.ItemTappedEventArgs e)
        {
            var tappedID = (e.Node.Content as FileManager)?.ID.ToString();
            if(tappedID != null)
            {
                this.GetResponse(tappedID);
                await App.Current.MainPage.Navigation.PushAsync(new DataFormPage());
            }
        }

        private void GetResponse(string Id)
        {
            ContactsInfo = new ContactsInfo();
            if (Id.Equals("1"))
            {
                ContactsInfo.Name = "Name1";
                ContactsInfo.ContactNumber = "123";
                ContactsInfo.Email = "xyz@mail.com";
                ContactsInfo.Address = "Address";
            }
            else if (Id.Equals("2"))
            {
                ContactsInfo.Name = "Name2";
                ContactsInfo.ContactNumber = "123";
                ContactsInfo.Email = "xyz@mail.com";
                ContactsInfo.Address = "Address";
            }
            else if (Id.Equals("3"))
            {
                ContactsInfo.Name = "Name3";
                ContactsInfo.ContactNumber = "123";
                ContactsInfo.Email = "xyz@mail.com";
                ContactsInfo.Address = "Address";
            }
        }

        protected override void OnDetachingFrom(BindableObject bindable)
        {
            base.OnDetachingFrom(bindable);
            dataForm = null;
        }
    }
}
